//
//  StationController.m
//  LTrain
//
//  Created by NYU User on 12/2/11.
//  Copyright (c) 2011 __MyCompanyName__. All rights reserved.
//

#import "StationController.h"
#import "StationView.h"
#import "LTrainAppDelegate.h"
#import "InfoController.h"

@implementation StationController

- (id) initWithNibName: (NSString *) nibNameOrNil bundle: (NSBundle *) nibBundleOrNil
{
	self = [super initWithNibName: nibNameOrNil bundle: nibBundleOrNil];
	if (self) {
		// Custom initialization
	}
	return self;
}

- (id) initWithTitle: (NSString *) title {
	self = [super initWithNibName: nil bundle: nil];
	if (self) {
		// Custom initialization
		self.title = title;
		LTrainAppDelegate *applicationDelegate = [UIApplication sharedApplication].delegate;

		//Everey station except the easternmost one has a "Go East" button.
		if ([applicationDelegate.names indexOfObject: title] < applicationDelegate.names.count - 1) {
			self.navigationItem.rightBarButtonItem = [[UIBarButtonItem alloc]
				initWithTitle: @"Go East"
				style: UIBarButtonItemStylePlain
				target: [UIApplication sharedApplication].delegate
				action: @selector(nextStation)
			];
		}
	}
	return self;
}

//Called when the user presses the StationView's "More Info" button.
//Create an InfoController and display it modally.

- (void) moreInfo {
	LTrainAppDelegate *applicationDelegate = [UIApplication sharedApplication].delegate;
	NSString *information = [applicationDelegate.information objectForKey: self.title];

	InfoController *infoController = [[InfoController alloc]
		initWithTitle: self.title
		information: information 
	];

	//Create a navigation controller to make the infoController's navigation item
	//(containing the Done button) visible.
	UINavigationController *navigationController =
		[[UINavigationController alloc] initWithRootViewController: infoController];

	[self presentModalViewController: navigationController animated: YES];
}


- (void) didReceiveMemoryWarning
{
	// Releases the view if it doesn't have a superview.
	[super didReceiveMemoryWarning];

	// Release any cached data, images, etc that aren't in use.
}

#pragma mark - View lifecycle


// Implement loadView to create a view hierarchy programmatically, without using a nib.
- (void) loadView
{
	CGRect frame = [UIScreen mainScreen].applicationFrame;
	self.view = [[StationView alloc] initWithFrame: frame controller: self];
}


/*
// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void) viewDidLoad
{
	[super viewDidLoad];
}
*/

- (void) viewDidUnload
{
	[super viewDidUnload];
	// Release any retained subviews of the main view.
	// e.g. self.myOutlet = nil;
}

- (BOOL) shouldAutorotateToInterfaceOrientation: (UIInterfaceOrientation) interfaceOrientation
{
	// Return YES for supported orientations
	//return (interfaceOrientation == UIInterfaceOrientationPortrait);
	return YES;
}

@end
